msgpack::zone Class Reference

`#include <cpp03_zone.hpp>`

## Public Member Functions

| zone (size_t chunk_size=MSGPACK_ZONE_CHUNK_SIZE)
void * | allocate_align (size_t size, size_t align=MSGPACK_ZONE_ALIGN)
void * | allocate_no_align (size_t size)
void | push_finalizer (void(*func)(void *), void *data)
template<typename T >
void | push_finalizer (msgpack::unique_ptr< T > obj)
void | clear ()
void | swap (zone &o)
| zone (size_t chunk_size=MSGPACK_ZONE_CHUNK_SIZE) noexcept
void * | allocate_align (size_t size, size_t align=MSGPACK_ZONE_ALIGN)
void * | allocate_no_align (size_t size)
void | push_finalizer (void(*func)(void *), void *data)
template<typename T >
void | push_finalizer (msgpack::unique_ptr< T > obj)
void | clear ()
void | swap (zone &o)
template<typename T , typename... Args>
T * | allocate (Args... args)
| zone (zone &&)=default
zone & | operator= (zone &&)=default
| zone (const zone &)=delete
zone & | operator= (const zone &)=delete

## Static Public Member Functions

static void * | operator new (std::size_t size)
static void | operator delete (void *p)
static void * | operator new (std::size_t size, void *place)
static void | operator delete (void *p, void *place)
static void * | operator new (std::size_t size)
static void | operator delete (void *p) noexcept
static void * | operator new (std::size_t, void *mem) noexcept
static void | operator delete (void *, void *) noexcept

## Constructor & Destructor Documentation

## zone() [1/4]

msgpack::zone::zone | ( | size_t | chunk_size = `MSGPACK_ZONE_CHUNK_SIZE` | ) |

inline noexcept

Referenced by operator delete().

## zone() [2/4]

msgpack::zone::zone | ( | size_t | chunk_size = `MSGPACK_ZONE_CHUNK_SIZE` | ) |

noexcept

## zone() [3/4]

msgpack::zone::zone | ( | zone && |  | ) |

default

## zone() [4/4]

msgpack::zone::zone | ( | const zone & |  | ) |

delete

## Member Function Documentation

## allocate()

template<typename T , typename... Args>

T * msgpack::zone::allocate | ( | Args... | args | ) |

References msgpack::aligned_size(), allocate_align(), and MSGPACK_ZONE_ALIGNOF.

Referenced by msgpack::aligned_size(), and operator delete().

## allocate_align() [1/2]

void * msgpack::zone::allocate_align | ( | size_t | size,
|  | size_t | align = `MSGPACK_ZONE_ALIGN`
| ) |  |

inline

Referenced by msgpack::aligned_size(), allocate(), msgpack::type::define_map<>::msgpack_object(), msgpack::type::define_array<>::msgpack_object(), msgpack::type::define_array< Args >::msgpack_object(), msgpack::type::define_map< Args >::msgpack_object(), operator delete(), msgpack::adaptor::object_with_zone< const char * >::operator()(), msgpack::adaptor::object_with_zone< std::vector< bool, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::pair< T1, T2 > >::operator()(), msgpack::adaptor::object_with_zone< std::string >::operator()(), msgpack::adaptor::object_with_zone< std::forward_list< T, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::unordered_set< Key, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::list< T, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::unordered_map< K, V, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::array< char, N > >::operator()(), msgpack::adaptor::object_with_zone< std::deque< T, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::array< unsigned char, N > >::operator()(), msgpack::adaptor::object_with_zone< std::set< T, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::vector< T, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::vector< unsigned char, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::vector< char, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< msgpack::type::ext >::operator()(), msgpack::adaptor::object_with_zone< type::assoc_vector< K, V, Compare, Alloc > >::operator()(), msgpack::detail::unpack_array::operator()(), msgpack::adaptor::object_with_zone< std::array< T, N > >::operator()(), msgpack::detail::unpack_map::operator()(), msgpack::adaptor::object_with_zone< std::unordered_multiset< Key, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< std::unordered_multimap< K, V, Hash, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< T[N]>::operator()(), msgpack::adaptor::object_with_zone< std::tuple< Args... > >::operator()(), msgpack::adaptor::object_with_zone< std::multiset< T, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< char[N]>::operator()(), msgpack::adaptor::object_with_zone< T, typename msgpack::enable_if< detail::is_seq_no_pair_no_tuple< T >::value >::type >::operator()(), msgpack::adaptor::object_with_zone< const char[N]>::operator()(), msgpack::adaptor::object_with_zone< std::map< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< unsigned char[N]>::operator()(), msgpack::adaptor::object_with_zone< msgpack::type::tuple< Args... > >::operator()(), msgpack::adaptor::object_with_zone< const unsigned char[N]>::operator()(), msgpack::adaptor::object_with_zone< msgpack::type::array_ref< T > >::operator()(), msgpack::adaptor::object_with_zone< msgpack::type::array_ref< T[N]> >::operator()(), msgpack::adaptor::object_with_zone< std::multimap< K, V, Compare, Alloc > >::operator()(), msgpack::adaptor::object_with_zone< type::tuple<> >::operator()(), msgpack::detail::create_object_visitor::start_array(), msgpack::detail::create_object_visitor::start_map(), msgpack::detail::unpack_bin(), msgpack::detail::unpack_ext(), msgpack::detail::unpack_str(), msgpack::detail::create_object_visitor::visit_bin(), msgpack::detail::create_object_visitor::visit_ext(), and msgpack::detail::create_object_visitor::visit_str().

## allocate_align() [2/2]

void* msgpack::zone::allocate_align | ( | size_t | size,
|  | size_t | align = `MSGPACK_ZONE_ALIGN`
| ) |  |

## allocate_no_align() [1/2]

void * msgpack::zone::allocate_no_align | ( | size_t | size | ) |

inline

References msgpack::type::size().

Referenced by operator delete().

## allocate_no_align() [2/2]

void* msgpack::zone::allocate_no_align | ( | size_t | size | ) |

## clear() [1/2]

void msgpack::zone::clear | ( |  | ) |

inline

Referenced by operator delete().

## clear() [2/2]

void msgpack::zone::clear | ( |  | ) |

## operator delete() [1/4]

static void msgpack::zone::operator delete | ( | void * | p | ) |

inline static

## operator delete() [2/4]

static void msgpack::zone::operator delete | ( | void * | p,
|  | void * | place
| ) |  |

inline static

References allocate(), and zone().

## operator delete() [3/4]

static void msgpack::zone::operator delete | ( | void * | p | ) |

inline static noexcept

## operator delete() [4/4]

static void msgpack::zone::operator delete | ( | void * | ,
|  | void * |
| ) |  |

inline static noexcept

References allocate(), allocate_align(), allocate_no_align(), clear(), push_finalizer(), msgpack::type::size(), swap(), and zone().

## operator new() [1/4]

static void* msgpack::zone::operator new | ( | std::size_t | size | ) |

inline static

## operator new() [2/4]

static void* msgpack::zone::operator new | ( | std::size_t | size,
|  | void * | place
| ) |  |

inline static

References msgpack::type::size().

## operator new() [3/4]

static void* msgpack::zone::operator new | ( | std::size_t | size | ) |

inline static

References msgpack::type::size().

## operator new() [4/4]

static void* msgpack::zone::operator new | ( | std::size_t | ,
|  | void * | mem
| ) |  |

inline static noexcept

## operator=() [1/2]

zone& msgpack::zone::operator= | ( | zone && |  | ) |

default

## operator=() [2/2]

zone& msgpack::zone::operator= | ( | const zone & |  | ) |

delete

## push_finalizer() [1/4]

void msgpack::zone::push_finalizer | ( | void(*)(void *) | func,
|  | void * | data
| ) |  |

inline

Referenced by operator delete().

## push_finalizer() [2/4]

template<typename T >

void msgpack::zone::push_finalizer | ( | msgpack::unique_ptr< T > | obj | ) |

inline

## push_finalizer() [3/4]

void msgpack::zone::push_finalizer | ( | void(*)(void *) | func,
|  | void * | data
| ) |  |

## push_finalizer() [4/4]

template<typename T >

void msgpack::zone::push_finalizer | ( | msgpack::unique_ptr< T > | obj | ) |

## swap() [1/2]

void msgpack::zone::swap | ( | zone & | o | ) |

inline

References msgpack::type::size().

Referenced by operator delete().

## swap() [2/2]

void msgpack::zone::swap | ( | zone & | o | ) |

The documentation for this class was generated from the following files:

- /build/msgpack-c-kSv3lu/msgpack-c-3.0.1/include/msgpack/v1/detail/cpp03_zone.hpp
- /build/msgpack-c-kSv3lu/msgpack-c-3.0.1/include/msgpack/v1/detail/cpp11_zone.hpp